<?php
class ItemDao extends BaseDao{

  //コンストラクタ
  function __construct(){
    parent::__construct();
  }

  //デストラクタ
  function __destruct(){
    parent::__destruct();
  }

  //全アイテムの取得
  public function getAllItem(){
    is_null($this->mysqli) and $this->connect();
    $result = $this->mysqli->query("SELECT * FROM item");
    $item_array = array();

    while($row = $result->fetch_array(MYSQLI_ASSOC)){  //<--MYSQLI_NUMではなく
      $item = new Item();
      $item->setId($row["id"]);
      $item->setName($row["name"]);
      $item->setDetail($row["detail"]);
      $item->setPrice($row["price"]);
      $item->setQty($row["qty"]);
      $item_array[] = $item;      
    }
    $result->close();
    return $item_array;
  }

  //指定されたアイテムの取得
  private function getItem($sql){
    is_null($this->mysqli) and $this->connect();
    $result = $this->mysqli->query($sql);

    $item = null;

    if($result->num_rows != 0){
      $row = $result->fetch_array(MYSQLI_ASSOC);
      $item = new Item();
      $item->setId($row["id"]);
      $item->setName($row["name"]);
      $item->setDetail($row["detail"]);
      $item->setPrice($row["price"]);
      $item->setQty($row["qty"]);
    }
    $result->close();

    return $item;
  }

  //idでアイテムを取得
  public function getItemById($id){
    $id = $this->mysqli->real_escape_string($id);
    $sql = "SELECT * FROM item WHERE id = '$id'";
    return $this->getItem($sql);
  }

  //nameでアイテムを取得
  public function getItemByName($name){
    $name = $this->mysqli->real_escape_string($name);
    $sql = "SELECT * FROM item WHERE name = '$name'";
    return $this->getItem($sql);
  }

  //アイテムの更新
  public function updateItem($item){
    $item = $this->escapeStringItem($item);
    is_null($this->mysqli) and $this->connect();
    $sql = "UPDATE item SET
                         name = '" . $item->getName() . "',
                         detail = '" . $item->getDetail() . "',
                         price = '" . $item->getPrice() . "',
                         qty ='" . $item->getQty() . "'
            WHERE id = '" . $item->getId() . "'";
    if( !$this->mysqli->query($sql)){
      return "更新に失敗しました(1001) " . $this->mysqli->error . "\n";
    }
    return "更新しました";
  }

  //新規アイテムの登録
  public function insertItem($item){
    $item = $this->escapeStringItem($item);
    is_null($this->mysqli) and $this->connect();
    //idカラムに空を挿入することで，auto_incrementによるカウントアップ値
    //を代入できる
    $sql = "INSERT INTO item values ('',
                         '" . $item->getName() . "',
                         '" . $item->getDetail() . "',
                         '" . $item->getPrice() . "',
                         '" . $item->getQty() . "')";
    if( !$this->mysqli->query($sql)){
      return "登録に失敗しました(1002) " . $this->mysqli->error . "\n";
    }
    return "一件追加しました";
  }

  //指定されたアイテムの削除
  public function deleteItem($item){
    return $this->deleteItemById($item->getId());
  }

  //idで指定されたアイテムの削除
  public function deleteItemById($id){
    $id = $this->mysqli->real_escape_string($id);
    is_null($this->mysqli) and $this->connect();

    $sql = "DELETE FROM item WHERE id = '" . $id . "'";
    if( !$this->mysqli->query($sql)){
       $error_no = $this->mysqli->errno;
       if( $error_no == 1451){
         return "注文を１度でも受けた商品は在庫一覧から削除できません<br>(外部キー制約エラー)";
       }else{
         return "削除に失敗しました(1003) " . $this->mysqli->error . "\n";
       }
    }
    return "削除しました";
  }

  //Itemクラスの各プロパティから特殊文字をエスケープ
  private function escapeStringItem($item){ 
    $item->setId($this->mysqli->real_escape_string($item->getId()));
    $item->setName($this->mysqli->real_escape_string($item->getName()));
    $item->setDetail($this->mysqli->real_escape_string($item->getDetail()));
    $item->setPrice($this->mysqli->real_escape_string($item->getPrice()));
    $item->setQty($this->mysqli->real_escape_string($item->getQty()));
    return $item;
  }
}
?>
