<?php
class Order_mainDao extends BaseDao{

  //コンストラクタ
  function __construct(){
    parent::__construct();
  }

  //デストラクタ
  function __destruct(){
    parent::__destruct();
  }

  //全注文の取得
  public function getAllOrder_main(){
    is_null($this->mysqli) and $this->connect();
    $result = $this->mysqli->query("SELECT * FROM order_main");
    $order_main_array = array();

    while($row = $result->fetch_array(MYSQLI_ASSOC)){  //<--MYSQLI_NUMではなく
      $order_main = new Order_main();
      $order_main->setOrder_no($row["order_no"]);
      $order_main->setOrder_date($row["order_date"]);
      $order_main->setName($row["name"]);
      $order_main->setZip_code($row["zip_code"]);
      $order_main->setAddress($row["address"]);
      $order_main_array[] = $order_main;      
    }
    $result->close();
    return $order_main_array;
  }

  //指定された注文の取得
  private function getOrder_main($sql){
    is_null($this->mysqli) and $this->connect();
    $result = $this->mysqli->query($sql);

    $order_main = null;

    if($result->num_rows != 0){
      $row = $result->fetch_array(MYSQLI_ASSOC);
      $order_main = new Order_main();
      $order_main->setOrder_no($row["order_no"]);
      $order_main->setOrder_date($row["order_date"]);
      $order_main->setName($row["name"]);
      $order_main->setZip_code($row["zip_code"]);
      $order_main->setAddress($row["address"]);
    }
    $result->close();

    return $order_main;
  }

  //order_noで注文を取得
  public function getOrder_mainByOrder_no($order_no){
    $order_no = $this->mysqli->real_escape_string($order_no);
    $sql = "SELECT * FROM order_main WHERE order_no = '$order_no'";
    return $this->getOrder_main($sql);
  }

  //nameで注文を取得
  public function getOrder_mainByName($name){
    $name = $this->mysqli->real_escape_string($name);
    $sql = "SELECT * FROM order_main WHERE name = '$name'";
    return $this->getOrder_main($sql);
  }

  //注文の更新
  public function updateOrder_main($order_main){
    $order_main = $this->escapeStringOrder_main($order_main);
    is_null($this->mysqli) and $this->connect();
    $sql = "UPDATE order_main SET
                         order_date = '" . $order_main->getOrder_date() . "',
                         name = '" . $order_main->getName() . "',
                         zip_code = '" . $order_main->getZip_code() . "',
                         address ='" . $order_main->getAddress() . "'
            WHERE order_no = '" . $order_main->getOrder_no() . "'";
    if( !$this->mysqli->query($sql)){
      print "登録に失敗しました(1011) " . $this->mysqli->error . "\n";
    }
  }

  //新規注文の登録
  public function insertOrder_main($order_main){
    $order_main = $this->escapeStringOrder_main($order_main);
    is_null($this->mysqli) and $this->connect();
    $sql = "INSERT INTO order_main values ('',
                         '" . $order_main->getOrder_no() . "',
                         '" . $order_main->getOrder_date() . "',
                         '" . $order_main->getName() . "',
                         '" . $order_main->getZip_code() . "',
                         '" . $order_main->getAddress() . "')";
    if( !$this->mysqli->query($sql)){
      print "登録に失敗しました(1012) " . $this->mysqli->error . "\n";
    }
  }

  //指定された注文の削除
  public function deleteOrder_main($order_main){
    $this->deleteOrder_mainByOrder_no($order_main->getOrder_main());
  }

  //order_noで指定された注文の削除
  public function deleteOrder_mainByOrder_no($order_no){
    $order_no = $this->mysqli->real_escape_string($order_no);
    is_null($this->mysqli) and $this->connect();

    $sql = "DELETE FROM order_main WHERE order_no = '" . $order_no . "'";
    if( !$this->mysqli->query($sql)){
      print "削除に失敗しました(1013) " . $this->mysqli->error . "\n";
    }
  }

  //新規注文(order_main)と新規注文アイテム（order_item）の登録
  public function insertOrder_main_item($order_main,$order_item_array){
    $order_main = $this->escapeStringOrder_main($order_main);
    is_null($this->mysqli) and $this->connect();
    //order_mainへの注文の挿入
    $this->mysqli->autocommit(FALSE);
    $sql = "INSERT INTO order_main values (
                         '" . $order_main->getOrder_no() . "',
                         '" . $order_main->getOrder_date() . "',
                         '" . $order_main->getName() . "',
                         '" . $order_main->getZip_code() . "',
                         '" . $order_main->getAddress() . "')";
    if( !$this->mysqli->query($sql)){
      print "登録に失敗しました(1014) " . $this->mysqli->error . "\n";
      return false;
    }
    $item_dao = new ItemDao();
    foreach($order_item_array as $order_item){
      $order_item = $this->escapeStringOrder_item($order_item);
      //order_itemへの注文アイテムの挿入
      $sql = "INSERT INTO order_item values (
                         '" . $order_item->getOrder_no() . "',
                         '" . $order_item->getOrder_date() . "',
                         '" . $order_item->getItem() . "',
                         '" . $order_item->getQty() . "') ";
      if(!$this->mysqli->query($sql)){
        print "登録に失敗しました(1015) " . $this->mysqli->error . "\n";
        return false;
      }
    }
    $this->mysqli->commit();
    return true;
  }

  //Order_mainクラスの各プロパティから特殊文字をエスケープ 
  private function escapeStringOrder_main($order_main){
    $order_main->setOrder_no($this->mysqli->real_escape_string($order_main->getOrder_no()));
    $order_main->setOrder_date($this->mysqli->real_escape_string($order_main->getOrder_date()));
    $order_main->setName($this->mysqli->real_escape_string($order_main->getName()));
    $order_main->setZip_code($this->mysqli->real_escape_string($order_main->getZip_code()));
    $order_main->setAddress($this->mysqli->real_escape_string($order_main->getAddress()));
    return $order_main;
  }

  //Order_itemクラスの各プロパティから特殊文字をエスケープ 
  private function escapeStringOrder_item($order_item){
    $order_item->setOrder_no($this->mysqli->real_escape_string($order_item->getOrder_no()));
    $order_item->setOrder_date($this->mysqli->real_escape_string($order_item->getOrder_date()));
    $order_item->setItem($this->mysqli->real_escape_string($order_item->getItem()));
    $order_item->setQty($this->mysqli->real_escape_string($order_item->getQty()));
    return $order_item;
  }


}
?>
