<?php
require_once("BaseDao.php");
require_once("Order_item.php");
require_once("Item.php");
require_once("ItemDao.php");

session_start();
//注文番号の確認
isset($_SESSION["order_no"]) or die("不正な呼び出しです");

//フォームの値から注文をとりだし，$order_itemを生成．
//さらに$order_itemを配列$order_item_arrayに格納
$order_item_array = array();

foreach($_POST as $idx => $val){
  if($idx != "order_no" && $val > 0){ //注文番号以外で，注文個数が1個以上
    $order_item = new Order_item();
    $order_item->setItem($idx);
    $order_item->setQty($val);
    $order_item_array[] = $order_item;
  }
}
if(count($order_item_array) <= 0){
  //何も注文されていない場合
  die("一品以上ご注文ください");
}

//order_item_arrayをセッション変数に格納
$_SESSION["order_item_array"] = $order_item_array;
?>

<HTML lang="ja">
<HEAD>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>オンラインストア：確認</title>

<SCRIPT TYPE="text/javascript">
<!--
//submitの二重押し対策
function disableButton(){
  if(check()){
    document.form1.button1.disabled = true;
    submitForm();
  }
}
function submitForm(){
  document.form1.submit();
}
//入力漏れチェック
function check(){
  if(document.form1.name.value == ""){
    window.alert('お名前が未入力です');
    return false;
  }else if(document.form1.zip_code.value == ""){
    window.alert('〒番号が未入力です');
    return false;
  }else if(document.form1.address.value == ""){
    window.alert('住所が未入力です');
    return false;
  }else{
    return true;
  }
}
// -->
</SCRIPT>
</HEAD>

<BODY TEXT="black" BGCOLOR="white">

<!-- タイトル -->
<div align="center"><font size="5"><b>ご確認　</b></font><font size="3">注文内容をご確認いただき，間違いなければ送付先をご入力下さい</b><br></font>
</div>
<hr width="600" align="center">

<!-- フォーム開始 -->
<form action="purchase.php" method="POST" enctype="application/x-www-form-urlencoded" name="form1">

<table width="480" border="1" cellspacing="0" cellpadding="7" align="center">
<tr>
<th width=300 bgcolor="#CCCCFF">商品</th>
<th width=60 bgcolor="#CCCCFF">単価</th>
<th width=40 bgcolor="#CCCCFF">個数</th>
<th width=80 bgcolor="#CCCCFF">小計</th>
</tr>

<?php
$item = new Item();
$item_dao = new ItemDao();

$total_price = 0;
$total_qty = 0;

//配列$order_item_arrayから$order_itemを取り出す
foreach($order_item_array as $order_item){
  $item = $item_dao->getItemById($order_item->getItem());  
  if(is_null($item)){
    die("商品アイテムが見つかりません");
  }

  //小計
  $subtotal_price = $item->getPrice() * $order_item->getQty();
  //合計
  $total_price += $subtotal_price;
  $total_qty += $order_item->getQty(); 
  //注文商品の表示ここから
?>

<!-- 商品ID <?php print htmlspecialchars($item->getId(),ENT_QUOTES); ?>-->
<tr>
<td><b><?php print htmlspecialchars($item->getName(),ENT_QUOTES); ?></b></td>
<td align="right"><?php print  htmlspecialchars($item->getPrice(),ENT_QUOTES); ?> 円</td>
<td align="right"><?php print  htmlspecialchars($order_item->getQty(),ENT_QUOTES); ?> 個</td>
<td align="right"><?php print  htmlspecialchars($subtotal_price,ENT_QUOTES); ?> 円</td>
</tr>

<?php
  //注文商品の表示ここまで
}
$item_dao = null;
?>

<!-- 合計 -->
<tr>
<td><b>合計</b></td>
<td align="center"><b>ー</b></td>
<td align="right"><?php print htmlspecialchars($total_qty,ENT_QUOTES) ." 個"; ?></td>
<td align="right"><?php print htmlspecialchars($total_price,ENT_QUOTES) . " 円"; ?></td>
</tr>
</table>
<p>
<table align="center">
<tr>
  <td>お名前：</td><td><input type=text name="name" size="20" maxlength="20"></td>
</tr>
<tr>
  <td>〒番号：</td><td><input type=text name="zip_code" size="9" maxlength="9"><b>（※「ー」ハイフン無し）</b></td>
</tr>
<tr>
  <td>住所　：</td><td><input type=text name="address" size="50" maxlength="100"></td>
</tr>
</table>
<p>
<div align="center">
<input type="button" value="購　入" onClick="disableButton()" name="button1">　　<input type="reset" name="リセット">
</div>
</form>

<!-- フッター -->
<hr width="600" align="center">
<table width="600" border="0" align="center">
<tr>
<td align="right"><font size="2">＠ＩＴ LinuxSquare「今から始める MySQL入門」<br>
2007/06/25作成</font></td>
</tr>
</table>

</BODY>
</HTML>
